close all
clear
fs=1e6;
Ts=1/fs;
N=2^16;
f=fs/N:fs/N:(N)*fs/N;
fc=100e3;
tau=1/2/pi/fc;
Z=exp(1j*2*pi*f*Ts);
v_euler=(1-Z.^(-1))/Ts;
v_bilin=2/Ts*(1-Z.^(-1))./(1+Z.^(-1));
v_ct=1j*2*pi*f;
H_ct=1./(1+tau*v_ct);
H_euler=1./(1+tau*v_euler);
H_bilin=1./(1+tau*v_bilin);

figure(1)
set(gcf, 'Position', get(0, 'Screensize'));
plot(f,20*log10(abs(H_ct)),'linewidth',2);
hold all
plot(f,20*log10(abs(H_euler)),'linewidth',2);
plot(f,20*log10(abs(H_bilin)),'linewidth',2);
axis([0 fs -100 0])
set(gca,'fontsize',30)
title('Frequency response ')
legend('CT','Euler', 'Bilinear','location', 'southeast')
xlabel('Normalized frequency (f/fs)')
ylabel('H(dB)')


figure(2)
set(gcf, 'Position', get(0, 'Screensize'));
semilogx(f/fs,20*log10(abs(H_ct)),'linewidth',2);
hold all
semilogx(f/fs,20*log10(abs(H_euler)),'linewidth',2);
semilogx(f/fs,20*log10(abs(H_bilin)),'linewidth',2);
axis([0.001 0.5 -100 0])
set(gca,'fontsize',30)
title('Frequency response between 0 and fs/2 ')
legend('CT','Euler', 'Bilinear')
xlabel('Normalized frequency (f/fs)')
ylabel('H(dB)')


figure(3)
set(gcf, 'Position', get(0, 'Screensize'));
semilogx(f/fs,20*log10(abs(H_ct))-20*log10(abs(H_euler)),'linewidth',2);
hold all
semilogx(f/fs,20*log10(abs(H_ct))-20*log10(abs(H_bilin)),'linewidth',2);
axis([0.001 0.5 -10 50])
set(gca,'fontsize',30)
title('error with respect to the Continous Time Filter')
legend(' Euler', 'Bilinear')
xlabel('Normalized frequency (f/fs)')
ylabel('Difference of Module (dB)')