close all
fil_num=[1 -2 ]; %For a filter with a numerator 1-2Z^(-1)
fil_denum=[1 3 5];%and a denumerator 1+3Z^(-1)+5Z^(-2)
fil_input=[zeros(1,10), 1 , zeros(1,10)]; %Vector of 21 samples for the input signal from t=-10 to t=10


[hm,wr]=freqz(fil_num,fil_denum,1000); %Calculating the frequency response of the filter

t=-10:10;

fil_output=filter(fil_num,fil_denum,fil_input);%Filtering the input by the filter impulse response


figure(1)
plot(t,fil_input,'linewidth',2)
hold all
plot(t,fil_output,'linewidth',2)
set(gca, 'fontsize', 30)
legend('input','output');
title('filter time domain output')
xlabel('time (Ts)')
ylabel('Output')


figure(2)
plot(wr/2/pi,20*log10(abs((hm))),'linewidth',2)
hold all
set(gca, 'fontsize', 30)
title('filter frequency domain output')
xlabel('Normalized frequency')
ylabel('Gain (dB)')

figure(3)
[zeros_func, poles_func, gain] = tf2zp(fil_num,fil_denum); %  Octave
zplane(zeros_func,poles_func);
set(gca, 'fontsize', 30)
title('x zeros  o poles')
xlabel('real')
ylabel('Imaginary')